/******************************
 *     main.c    (abc850)
 ******************************/
#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/examples/i2c1_master_example.h"
#include <stdio.h>
#include "i2cLCD_AQM0802A.h"

uint16_t aVal;
uint16_t pwmV;
uint8_t  trDrc = 1;
uint8_t  inDrc = 0;
uint8_t  IrFlg;

void dsp_sts(uint8_t a){
    LCD_cursor(0,0);
    switch(a){
        case 0:
            LCD_str("NoPwr");
            break;
        case 1:
            LCD_str("Ready");
            break; 
        case 2:
            LCD_str("Forwd");
            break; 
        case 3:
            LCD_str("Revrs");
            break; 
    }
}
void dsp_num(uint8_t x, uint16_t n){
    char sBuf[10];
    sprintf(sBuf,"%4d",n);
    LCD_cursor(x,1);
    LCD_str(sBuf);    
}

void stop_wait_Vr_Zero(void)
{
    Led_A5_SetHigh();
    PWM5_LoadDutyValue(0);
    CWG1STR = 0xF5;
    pwmV = 0;
    dsp_sts(0);
    dsp_num(0, pwmV);
    do{
        aVal = ADC_GetConversion(Vr_C5);
        dsp_num(4, aVal);
    }while(aVal > 0);
    Led_A5_SetLow();
    dsp_sts(trDrc + 2);
}

void main(void)
{
  SYSTEM_Initialize();
  INTERRUPT_GlobalInterruptEnable();
  INTERRUPT_PeripheralInterruptEnable();
    
  DACCON1 = 0x03;
  LCD_init();
  stop_wait_Vr_Zero();
    
  while (1)
  {
    if(CWG1AS0bits.CWG1SHUTDOWN || IrFlg){
      stop_wait_Vr_Zero();
      CWG1_AutoShutdownEventClear();
      trDrc ^= 0x01;
      IrFlg = 0;
    }    
    if(Ps_A3_PORT == 0){
      inDrc ^= 0x01;
    }
    if(trDrc != inDrc){
      stop_wait_Vr_Zero();
      trDrc = inDrc;
      if(trDrc == 0){
        CWG1STR = 0xF1;
      }else{
        CWG1STR = 0xF4;
      }
    }
    aVal = ADC_GetConversion(Vr_C5);
    pwmV = aVal;
    PWM5_LoadDutyValue(pwmV);
    dsp_num(0,pwmV);
    dsp_num(4,aVal);
  }
}
